#include <pgapplication.h>
#include <pglineedit.h>
#include <pgwindow.h>

PG_LineEdit* myedit;
PG_Window* mydialog;


bool button_clicked(int id, PG_Widget* widget, unsigned long data, void* clientdata)
{
    //When the button is clicked, we want to delete the input object.
    //This should lead to a segfault.
    mydialog->RemoveChild(myedit);
    
    myedit->Hide(); //if the edit widget is active (input), hiding it will
                    //send a message which is only processed when the object
                    //is already deleted later on
    delete myedit;
    myedit = 0;

    return true;
}


int main()
{
    //init the application (uninteresting part)
    PG_Application app;
    app.SetEmergencyQuit(true);
    app.LoadTheme("default");
    app.InitScreen(640, 480);

    //set up the dialog with a button. The button should call a function
    //locally.
    mydialog = new PG_Window(0, PG_Rect(0,0,300,300), "test");
    PG_Button but(mydialog, 0, PG_Rect(100, 200, 100, 30), "Quit");
    but.SetEventCallback(MSG_BUTTONCLICK, (MSG_CALLBACK)&button_clicked);

    //finally, we set up the myedit
    myedit = new PG_LineEdit(mydialog, PG_Rect(100, 50, 100, 30));
    myedit->SetText("Test");

    //finally, start up paragui
    mydialog->Show();
    app.Run();

    return 0;
}

